var pCnn = null;

/* ----------------------------------------
	 ADO
------------------------------------------*/
	
//---- CursorTypeEnum Values ----
var adOpenForwardOnly = 0;
var adOpenKeyset = 1;
var adOpenDynamic = 2;
var adOpenStatic = 3;

//---- LockTypeEnum Values ----
var adLockReadOnly = 1;
var adLockPessimistic = 2;
var adLockOptimistic = 3;
var adLockBatchOptimistic = 4;

//---- CommandTypeEnum Values ----
var adCmdUnknown = 0x0008;
var adCmdText = 0x0001;
var adCmdTable = 0x0002;
var adCmdStoredProc = 0x0004;
var adCmdFile = 0x0100;
var adCmdTableDirect = 0x0200;


/* ----------------------------------------
	
------------------------------------------*/

var CONFIG = new ActiveXObject("MSXML2.DOMDocument");

// 20 
var G_PAGE_SIZE = getParam("page-size");
//  
var G_LIMIT		= getParam("max-records");
//  
var G_FLAME 	= getParam("conf") == null ? getParam("default-conf") : getParam("conf");
// 
var G_HOST  	= getParam("host");
var G_POST      = getParam("post");
// 
var G_USER		= getParam("user");


/**
*
*/
	
function getForumTitle(n)
{
	var pRs = null;
	try
	{
		pRs = pCnn.Execute("select title from forums where n = " + n);
		return "" + pRs("title").Value;
	}
	finally
	{
		pRs.Close();
		pRs = null;
	}
}	

function getCurrentForum()
{
	return G_FLAME;
}

/**
*  x G_LIMIT 
*/
function getSQL()
{
	return 	"select top " + G_LIMIT + " *, (select count(id) from answers a where a.id = f.id) as indb from flame f where (archived is null or archived <> 1)  and n=" + getCurrentForum() + " order by lastmod desc";
}

/**
*    XML
*/
function getParam(key)
{
	CONFIG.load("params.xml");
	var pNode = CONFIG.selectSingleNode("/params/param[@name='" + key + "']");
	if (pNode != null)
		return pNode.getAttribute("value");
	return "";
}

function SaveToFile(Str, FileName)
{
	var pStm = new ActiveXObject("ADODB.Stream");
	pStm.Open();
	pStm.WriteText(Str);
	pStm.SaveToFile(FileName);
	pStm.Close();
}

/**
*  
*/
function setParam(key, value)
{
	var pDoc = new ActiveXObject("MSXML2.DomDocument");
	pDoc.load("params.xml");
	var pNode = pDoc.selectSingleNode("/params/param[@name='" + key + "']");
	if (pNode != null)
	{
		pNode.setAttribute("value", value);
	}
	else
	{
		pNode = pDoc.createElement("param");
		pDoc.documentElement.appendChild(pNode);
		pNode.setAttribute("name", key);
		pNode.setAttribute("value", value);	
	}
	pDoc.save("params.xml");
}

/**
*    
*/
function Init()
{
	try
	{
		pCnn = new ActiveXObject("ADODB.Connection");
		pCnn.ConnectionString = "FILE NAME=dm.udl";
		pCnn.Open();
	}
	catch (e)
	{
		alert("     : " + e.message);
	}
}

function SplitByCrLf(Str)
{
	return Str.split("\r\n");
}

function SplitByTab(Str)
{
	return Str.split("\t");
}

/**
*   . 
*  , ..  "" 
*    
*/
function Navigate(Method, Url)
{
	try
	{
		var pR = new ActiveXObject("Microsoft.XMLHTTP");
		pR.open(Method, Url, false);
		pR.send();
		return pR.responseText;
	}
	catch (e)
	{
		throw e;
	}
}

/**
*  ,    -,  XML
*/
function toXML(Str, RootElemName)
{
	var iErrCnt = 0;
	var pXML = new ActiveXObject("MSXML2.DOMDocument");
	pXML.async = false;
	
	var pRoot = pXML.createElement(RootElemName);
	pXML.appendChild(pRoot);
	var sAllStrings = SplitByCrLf(Str);
	if (sAllStrings.length == 0)
	{
		setStatus(" ");
		return pXML;
	} 
	var arrCnt = sAllStrings[0].split("=");
	if (arrCnt[0] == "ERROR") 
		throw arrCnt[1];
	pRoot.setAttribute("count", arrCnt[1]);
	for (var i = 1; i < sAllStrings.length - 1; i++) // -1! 
	{
		try
		{
			var pRow = pXML.createElement("row");
			var sFields = SplitByTab(sAllStrings[i]);
			for (var j = 0; j < sFields.length; j++)
			{
				var sPair = sFields[j].split("=", 2);
				pRow.setAttribute(sPair[0], sPair[1]);
				pRoot.appendChild(pRow);
			}
		}
		catch (e)
		{
			iErrCnt++;		
		}
	}
	if (iErrCnt != 0)
	{
		pXML.documentElement.setAttribute("errcnt", " " + iErrCnt);
	}
	return pXML;
}



/**
* ...
*/
function QueryToXML(Query, RootElementName)
{
	var pXML = new ActiveXObject("MSXML2.DomDocument");
	pXML.async = false;
	var pRs  = null;
	try
	{
		pRs = pCnn.Execute(Query);
		var pRoot = pXML.createElement(RootElementName);
		pXML.appendChild(pRoot);
		while (!pRs.EOF)
		{
			var pRow = pXML.createElement("row");
			pRoot.appendChild(pRow);
			for (var i = 0; i < pRs.Fields.Count; i++)
			{
				pRow.setAttribute(pRs.Fields.Item(i).Name, pRs.Fields.Item(i).Value == null ? "" : pRs.Fields.Item(i).Value );
			}
			pRs.MoveNext();
		}
		return pXML;
	}
	finally
	{
		pRs = null;	
	}
}

/**
*  ,   XML-  
*  XSL-. Params -  , , -
* ,  XSL-.  JScript
*   :
* var pArr = {key1:value1, key2:value2};
*/
function Transform(pXML, pXSLFileName, Params)
{
	var pXSLT = new ActiveXObject("Msxml2.XSLTemplate");
	var pXSL  = new ActiveXObject("Msxml2.FreeThreadedDOMDocument");
	try
	{
		pXSL.async = false;
		pXSL.load(pXSLFileName);
		pXSLT.stylesheet = pXSL;
		var pXSLProc = pXSLT.createProcessor();
		pXSLProc.input = pXML;
		if (Params != null)
		{
			for (key in Params)
			{
				pXSLProc.addParameter(key, Params[key]);
			}	
		}
		pXSLProc.transform();
		return pXSLProc.output; 
	}
	finally
	{
		pXSLT = null;
		pXSL  = null;
		pXSLProc = null;	
	}
} 

/**
*  
*/
function escapeHTML(str)
{
	var re = /&/g;
	str = str.replace(re, "&amp;");
	re = />/g;	
	str = str.replace(re, "&gt;");
	re = /</g;
	str = str.replace(re, "&lt;");
	re = /\"/g;
	str = str.replace(re, "&quot;");
	re = /\'/g;
	str = str.replace(re, "&pos;");
	return str;
}

function getTitleByN(n)
{
	var pRs = null;
	try
	{
		pRs = pCnn.Execute("select title from forums where n = " + n);
		if (pRs.EOF) return "";
		return pRs("title");
	}
	finally
	{
		pRs = null;
	}
}

/**
*      -   .
*/
function SaveMessage()
{
	var pRs = new ActiveXObject("ADODB.Recordset");
	try
	{
		var pN  = document.getElementById("__n");
		var pId = document.getElementById("__id");
	
		var pUser = document.getElementById("__user");
		if (pUser == null)
		{
			alert("User field is null");
			return;
		}
		var pMessage = document.getElementById("__message");
		if (pMessage == null)
		{
			alert("Message field is null");
			return;
		}
		
		var pTitle = document.getElementById("__title");
		
		pRs.Open("select top 1 * from outbox", pCnn, adOpenKeyset, adLockOptimistic, adCmdText);
		pRs.AddNew();
		pRs("n")  = (pN  == null? "-1" : pN.value);
		pRs("id") = (pId == null? "0" : pId.value);
		pRs("user") = pUser.value;
		pRs("message") = pMessage.value;
		pRs("title") = (pTitle == null ? "" : pTitle.value);
		pRs.Update();			
		//alert("   .      ''''   ");
		setParam("user", pUser.value);
		pMessage.innerHTML = "";
		try
		{
			window.close();
		}
		catch (ex) {}
	}
	catch (e)
	{
		alert(".      : " + e.Message);
	}
	finally
	{
		pRs = null;
	}
}