﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">	
		
	<xsl:output method="html" encoding="windows-1251"/>

	<xsl:param name="id" select="0"/>
	<xsl:param name="n" select="-1"/>

	<xsl:template name="links">
		<select id="cboMessages" onchange="scrollToMessage(this.selectedIndex)">
			<xsl:call-template name="opt"/>
		</select><br/>
	</xsl:template>
	
	<xsl:template name="opt">
		<xsl:param name="i" select="0"/>
		<option value="#msg{$i}"><xsl:value-of select="$i"/></option>
		<xsl:if test="$i &lt; count(/ROOT/row)">
			<xsl:call-template name="opt">
				<xsl:with-param name="i" select="$i + 1"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
	
	<xsl:template match="/ROOT">
			<xsl:if test="count(./row) = 0">
				<div align="center" style="padding:20px">(ответы не загружены)</div>
			</xsl:if>
		<!--table width="100%" border="0"-->
			<xsl:for-each select="./row">
				<div class="msg">
					<xsl:variable name="iPos" select="position()"/>
					<xsl:if test="position() != 1">
						[<xsl:value-of select="position() - 1"/>]
					</xsl:if>
					<xsl:value-of select="@answer" disable-output-escaping="yes"/>
					<br/>
					<a href="javascript:void(0)" onclick="parent.NewMessage({@id}, {$iPos - 1});return false"> Ответить</a> | 
					<a href="javascript:void(0)" onclick="parent.RemoveMessage({@id},{@c});return false"> Удалить</a>
				</div>
			</xsl:for-each>
		<br/>
		
		<!--xsl:call-template name="editor">
			<xsl:with-param name="id"   select="$id"/>
			<xsl:with-param name="n"    select="$n"/>
		</xsl:call-template-->
	</xsl:template>
</xsl:stylesheet>