﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">	
	<xsl:output method="html" encoding="windows-1251"/>
	<xsl:strip-space elements="*"/>
	<xsl:template name="bg">
		<xsl:if test="position() mod 2 = 1">
			<!--#FFDDDD-->
			<xsl:attribute name="bgcolor">#F6F6F6</xsl:attribute>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="/ROOT">
		<div style="background-color:buttonshadow;color:window;padding:3px"><b>Всего в конференции 
			<xsl:choose>
				<xsl:when test="count(./row) >= 1000"> более 1000 </xsl:when>
				<xsl:otherwise><xsl:value-of select="count(./row)"/></xsl:otherwise> 
			</xsl:choose>			
		сообщений</b></div>
		<table border="0" cellpadding="0" cellspacing="0" style="cursor: default">
		<tr>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" width="16" title="Сообщение"><img src="i/e.gif"/></td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" width="16" align="center" title="Пометить"><img src="i/e.gif"/></td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" title="Тема сообщения" width="200"><img src="i/e.gif" width="3" height="18" align="absmiddle"/>Тема:</td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" title="Всего сообщений в этой ветке" width="25"><img src="i/e.gif" width="3" height="18" align="absmiddle"/>Всего:</td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" title="Всего загружено" width="25"><img src="i/e.gif" width="3" height="18" align="absmiddle"/>Загружено:</td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" title="Отправитель" width="100"><img src="i/e.gif" width="3" height="18" align="absmiddle"/>От:</td>
		<td valign="middle" style="cursor:default;border:1px outset;background-color:buttonface" title="Дата" width="100"><img src="i/e.gif" width="3" height="18" align="absmiddle"/>Дата:<img src="i/e.gif" width="3" height="18" align="absmiddle"/></td></tr>
		<xsl:for-each select="./row">
			<tr>
				<td><xsl:call-template name="bg"/>
				<input id="im{@id}" height="14" width="14" style="border-bottom:1px solid buttonshadow; border-right:1px solid buttonshadow; border-top:1px solid buttonface; border-left:1px solid buttonface" type="image" src="i/mail.png" title="Нажмите, чтобы загрузить новые сообщения этой ветки..." onclick="javascript:parent.LoadAnswers({@id}, {@n}); return false" value="&gt;"/></td>
				<td><xsl:call-template name="bg"/>
					<input onclick="parent.Mark(this, {@id})" style="margin:0;padding:0; height:14px; width:14px; cursor: hand" type="checkbox" marked="{@id}" title="Пометить">
						<xsl:if test="@marked=1">
							<xsl:attribute name="checked">checked</xsl:attribute>
						</xsl:if>
					</input>
				</td>
				<td nowrap="nowrap"><xsl:call-template name="bg"/><b>
					<a type="header" href="javascript:void(0)" onclick="javascript:parent.ShowAnswers({@id});return false" title="{concat('Нажмите, чтобы отобразить ответы темы &quot;', @title, '&quot;')}">
					<xsl:choose>
						<xsl:when test="string-length(@title) &lt;= 50">
							<xsl:value-of select="@title" disable-output-escaping="yes"/>
						</xsl:when>		
						<xsl:otherwise>
							<xsl:value-of select="concat(substring(@title, 0, 47), '...')"/>
						</xsl:otherwise>
					</xsl:choose>
					</a>
				</b></td>
				<td align="center"><xsl:call-template name="bg"/>
					<xsl:choose>
						<xsl:when test="@count = 0">1</xsl:when>
						<xsl:otherwise><xsl:value-of select="@count"/></xsl:otherwise>
					</xsl:choose>
				</td>
				<td align="center"><xsl:call-template name="bg"/>
					<xsl:choose>
						<xsl:when test="@indb = 0">(нет)</xsl:when>
						<xsl:when test="@indb = 1">1</xsl:when>
						<xsl:otherwise><xsl:value-of select="@indb - 1"/></xsl:otherwise>
					</xsl:choose>
				</td>
				<td nowrap="nowrap"><xsl:call-template name="bg"/><xsl:value-of select="@name"/></td>
				<td nowrap="nowrap"><xsl:call-template name="bg"/><xsl:value-of select="@date"/></td>
			</tr>
			<tr><td colspan="7" bgcolor="#999999"><img src="i/e.gif" width="1" height="1"/></td></tr>	
		</xsl:for-each>
		</table>
	</xsl:template>
</xsl:stylesheet>