﻿<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">	
	
	<xsl:param name="n" select="-11"/>
	<xsl:param name="id" select="0"/>
	<xsl:param name="body" select="''"/>
	

	<xsl:variable name="user" 		select="document('../params.xml')/params/param[@name='user']/@value"/>
	<xsl:variable name="password" 	select="document('../params.xml')/params/param[@name='password']/@value"/>
	<xsl:variable name="host" 		select="document('../params.xml')/params/param[@name='post']/@value"/>
	<xsl:variable name="sign"       select="document('../params.xml')/params/param[@name='sign']/@value"/>	

	<xsl:output method="html" encoding="windows-1251"/>
	
	
	
	<xsl:template match="/ROOT">
		<xsl:call-template name="editor">
			<xsl:with-param name="n"  select="$n"/>
			<xsl:with-param name="id" select="$id"/>
			<xsl:with-param name="body" select="$body"/>
		</xsl:call-template>
	</xsl:template>
	
	<xsl:template name="editor">
		<xsl:param name="n"    select="-1"/>
		<xsl:param name="id"   select="'0'"/>
		<xsl:param name="body" select="''"/>
		<input id="__n" type="hidden" name="n" value="{$n}"/>
		<xsl:if test = "$id != 0">
			<input id="__id" type="hidden" name="id" value="{$id}"/>
		</xsl:if>
		<input type="hidden" name="icon" value="13"/>
		<input type="hidden" name="p" value="1"/>
		
		<xsl:choose>
			<xsl:when test="$id = 0">
				<input type="hidden" name="add" value="Добавить"/>
			</xsl:when>
			<xsl:otherwise>
				<input type="hidden" name="add2" value="Добавить"/>
			</xsl:otherwise>
		</xsl:choose>
		
		<table width="100%" border="0">
			<tr>
				<td rowspan="3" width="32" valign="top">
					<br/>
					<span style="filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src='i/envelope.png');height:32; width:32; top:10"></span>
				</td>
				<td width="50"></td>
				<td></td>
			</tr>
			<tr>
				<td width="50">Тема:</td>
				<td>
					<input id="__title" name="title" value="" type="text">
						<xsl:choose>
							<xsl:when test="$id != 0">
								<xsl:attribute name="disabled">false</xsl:attribute>
								<xsl:attribute name="style">border:1px solid buttonshadow; background-color: buttonface;width:100%</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="style">border:1px solid buttonshadow; width:100%</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</input>
				</td>
			</tr>
			<tr>
				<td width="50">Имя:</td>
				<td><input id="__user"  name="name" value="{$user}" style="border:1px solid buttonshadow" type="text"/>
			</td></tr>
			<!--tr><td width="50">Пароль:</td><td><input id="__pass"  name="topsw" value="" style="border:1px solid #666666" type="password"/></td></tr-->
			<tr><td colspan="3"><textarea id="__message" name="text" style="width:100%; height:150px; border:1px solid buttonshadow">
				<xsl:value-of select="$body" disable-output-escaping="yes"/>
				<xsl:value-of select="$sign" disable-output-escaping="yes"/>
			</textarea></td></tr>
			<tr><td colspan="3" align="right">
				<input type="button" value="Отправить" >
					<xsl:attribute name="onclick">
						SaveMessage()
					</xsl:attribute>
				</input>
			</td></tr>
		</table>
		<script>__message.focus();</script>
	</xsl:template>
	
	
</xsl:stylesheet>